﻿using System;
using System.Windows.Forms;

namespace ZoomLcdChar
{
    public partial class FormTest : Form
    {
        public FormTest()
        {
            InitializeComponent();
        }

        // обработка события изменения символа
        private void zoomLcdChar1_ZoomLcdCharChanged(object sender, EventArgs e)
        {
            bool[,] symbol = zoomLcdChar1.GetDots(); // Получение массива точек символа.
            if (symbol.Length == 40) // простенькая проверка, что мы получили то, что хотели - массив из 40 элементов
            {                        // это не идеальная проверка. Но достаточная. 
                tb_ResultArray.Text = "{"; // Очистка текстового поля, записью фигурной скобки (формирование в виде массива). 
                for (int y = 0; y < 8; y++) // Перебор строк.
                {
                    byte b = 0; // Инициализация байта строки.            
                    for (int x = 0; x < 5; x++) // Перебор строки.
                        if (symbol[x, y])  // если точка установлена...         
                            b |= (byte)(1 << (4 - x)); //...то установка соответствующего бита в байте. 
                                                       // (4-х) делает переворот нумерации, так как в массиве она идет 
                                                       // слева направо, а биты в байте - справа налево.
                    string hex = b.ToString("X");// Вывод байта в текстовом шестнадцатеричном 
                    tb_ResultArray.Text += "0x" + (hex.Length > 1 ? hex : "0" + hex);// (за счет указания формата "X") виде, с дополнением ноля.
                                                                  
                    if (y < 7) // Если это не последняя строка...
                        tb_ResultArray.Text += " ,"; //... то подготовка к следующему элементу: добавляется пробел и запятая.
                    else
                        tb_ResultArray.Text += "}"; //... иначе завершение строки массива символом фигурной скобки.
                }
            }               
        }
    }
}
